/**
	Definitions for a simple example
	Rendering a Lit Sphere
	From Book: OpenGL Programming Guide
	5th edition
	Shreiner, Woo, Neider, Davis
	Addison Wesley

	Fraga 02/12/2005
**/
#ifndef SPHERE_H
#define SPHERE_H

#include <QWidget>
#include <QtOpenGL>
#include <QTimer>
#include <glu.h>

class Sphere : public QGLWidget
{
	Q_OBJECT  // must include this if you use Qt signals/slots
public:
	Sphere( QWidget *parent=0 );
	~Sphere( );
	QSizePolicy sizePolicy() const;
	void getPosition ( int *x, int *y ) { *x = xmouse; *y = ymouse; }
	void getSize ( int *w, int *h ) { 
		*w = windowWidth; *h = windowHeight; 
	}

public slots:
	void timerDone( void );
	void initscreen( void ) { 
		timer->start(100);
	}
	void stop( void ) {
		timer->stop( );
 	} 

signals:
	void changePos( ); // called when mouse is moved
	void changeSize( ); // called when windows is resized
 
protected:
	void initializeGL( void );
	void resizeGL( int w, int h );
	void paintGL( void );
	void mouseMoveEvent( QMouseEvent * );
	void keyPressEvent ( QKeyEvent * e );
	// void mousePressEvent( QMouseEvent * );
 
 
private:
	QTimer *timer;

	int windowWidth, windowHeight;   // canvas width and height

	float yrot, xrot;  // Encene rotation

	float angle;
	int signo;
	int xmouse, ymouse;  // Mouse pointer coordinates

	GLUquadricObj *sphere;
	GLuint slist;
};


#endif // SPHERE_H
